Index: vi/v_left.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_left.c	Sun Apr 28 00:20:33 1996
--- nvi-1.79-m17n/vi/v_left.c	Sun Nov 24 13:37:17 1996
***************
*** 36,41 ****
--- 36,44 ----
  	VICMD *vp;
  {
  	recno_t cnt;
+ #ifdef MULTIBYTE
+ 	CHAR_T	*p;
+ #endif
  
  	/*
  	 * !!!
***************
*** 46,56 ****
  		return (1);
  	}
  
  	/* Find the end of the range. */
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
! 	if (vp->m_start.cno > cnt)
  		vp->m_stop.cno = vp->m_start.cno - cnt;
! 	else
  		vp->m_stop.cno = 0;
  
  	/*
--- 49,71 ----
  		return (1);
  	}
  
+ #ifdef MULTIBYTE
+ 	/* we need the content of the line.  */
+ 	if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 		return (1);
+ #endif /*MULTIBYTE*/
+ 
  	/* Find the end of the range. */
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
! 	if (vp->m_start.cno > cnt) {
! #ifndef MULTIBYTE
  		vp->m_stop.cno = vp->m_start.cno - cnt;
! #else
! 		vp->m_stop.cno = vp->m_start.cno;
! 		while (cnt--)
! 			vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
! #endif /*MULTIBYTE*/
! 	} else
  		vp->m_stop.cno = 0;
  
  	/*
***************
*** 58,65 ****
  	 * adjust the starting point to the character before the current
  	 * one.
  	 */
! 	if (ISMOTION(vp))
  		--vp->m_start.cno;
  	vp->m_final = vp->m_stop;
  	return (0);
  }
--- 73,85 ----
  	 * adjust the starting point to the character before the current
  	 * one.
  	 */
! 	if (ISMOTION(vp)) {
! #ifndef MULTIBYTE
  		--vp->m_start.cno;
+ #else
+ 		vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif
+ 	}
  	vp->m_final = vp->m_stop;
  	return (0);
  }
***************
*** 144,149 ****
--- 164,173 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
+ 
  	/*
  	 * !!!
  	 * Yielding to none in our quest for compatibility with every
***************
*** 172,177 ****
--- 196,209 ----
  		return (1);
  	}
  
+ #ifdef MULTIBYTE
+ 	if (ISMOTION(vp)) {
+ 		/* we need the content of this line. */
+ 		if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 			return (1);
+ 	}
+ #endif /*MULTIBYTE*/
+ 
  	/*
  	 * If moving right, non-motion commands move to the end of the range.
  	 * Delete and yank stay at the start.  Motion commands adjust the
***************
*** 183,195 ****
  	 */
  	if (vp->m_start.cno < vp->m_stop.cno)
  		if (ISMOTION(vp)) {
  			--vp->m_stop.cno;
  			vp->m_final = vp->m_start;
  		} else
  			vp->m_final = vp->m_stop;
  	else {
! 		if (ISMOTION(vp))
  			--vp->m_start.cno;
  		vp->m_final = vp->m_stop;
  	}
  	return (0);
--- 215,236 ----
  	 */
  	if (vp->m_start.cno < vp->m_stop.cno)
  		if (ISMOTION(vp)) {
+ #ifndef MULTIBYTE
  			--vp->m_stop.cno;
+ #else
+ 			vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif
  			vp->m_final = vp->m_start;
  		} else
  			vp->m_final = vp->m_stop;
  	else {
! 		if (ISMOTION(vp)) {
! #ifndef MULTIBYTE
  			--vp->m_start.cno;
+ #else
+ 			vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif
+ 		}
  		vp->m_final = vp->m_stop;
  	}
  	return (0);
***************
*** 208,213 ****
--- 249,258 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
+ 
  	if (F_ISSET(vp, VC_C1SET) && vp->count > 1) {
  		--vp->count;
  		vp->m_stop.cno =
***************
*** 236,241 ****
--- 281,294 ----
  		vp->m_stop.cno = 0;
  	}
  
+ #ifdef MULTIBYTE
+ 	if (ISMOTION(vp)) {
+ 		/* we need the content of this line. */
+ 		if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 			return (1);
+ 	}
+ #endif /*MULTIBYTE*/
+ 
  	/*
  	 * If moving right, non-motion commands move to the end of the range.
  	 * Delete and yank stay at the start.  Motion commands adjust the
***************
*** 247,259 ****
  	 */
  	if (vp->m_start.cno < vp->m_stop.cno)
  		if (ISMOTION(vp)) {
  			--vp->m_stop.cno;
  			vp->m_final = vp->m_start;
  		} else
  			vp->m_final = vp->m_stop;
  	else {
! 		if (ISMOTION(vp))
  			--vp->m_start.cno;
  		vp->m_final = vp->m_stop;
  	}
  	return (0);
--- 300,321 ----
  	 */
  	if (vp->m_start.cno < vp->m_stop.cno)
  		if (ISMOTION(vp)) {
+ #ifndef MULTIBYTE
  			--vp->m_stop.cno;
+ #else
+ 			vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif
  			vp->m_final = vp->m_start;
  		} else
  			vp->m_final = vp->m_stop;
  	else {
! 		if (ISMOTION(vp)) {
! #ifndef MULTIBYTE
  			--vp->m_start.cno;
+ #else
+ 			vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif
+ 		}
  		vp->m_final = vp->m_stop;
  	}
  	return (0);
***************
*** 270,275 ****
--- 332,341 ----
  	SCR *sp;
  	VICMD *vp;
  {
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
+ 
  	/*
  	 * !!!
  	 * The 0 command succeeded if used as a command in the first column
***************
*** 286,293 ****
  	 * one.
  	 */
  	vp->m_stop.cno = 0;
! 	if (ISMOTION(vp))
  		--vp->m_start.cno;
  	vp->m_final = vp->m_stop;
  	return (0);
  }
--- 352,369 ----
  	 * one.
  	 */
  	vp->m_stop.cno = 0;
! 	if (ISMOTION(vp)) {
! #ifndef MULTIBYTE
  		--vp->m_start.cno;
+ #else
+ 		/* we need the content of this line. */
+ 		if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 			return (1);
+ 		
+ 		vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif /*MULTIBYTE*/
+ 
+ 	}
  	vp->m_final = vp->m_stop;
  	return (0);
  }
Index: vi/v_match.c
Prereq: 	10.8 
*** nvi-1.79/vi/v_match.c	Sun Apr 28 00:21:26 1996
--- nvi-1.79-m17n/vi/v_match.c	Thu Feb 20 00:04:02 1997
***************
*** 31,36 ****
--- 31,42 ----
   *
   * PUBLIC: int v_match __P((SCR *, VICMD *));
   */
+ #ifdef MULTIBYTE
+ /*
+  * XXX
+  * There should be a way to handle multibyte parentheses/brackets matching.
+  */
+ #endif
  int
  v_match(sp, vp)
  	SCR *sp;
***************
*** 40,46 ****
--- 46,56 ----
  	MARK *mp;
  	size_t cno, len, off;
  	int cnt, isempty, matchc, startc, (*gc)__P((SCR *, VCS *));
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	/*
  	 * !!!
***************
*** 55,61 ****
  			goto nomatch;
  		return (1);
  	}
! 	for (off = vp->m_start.cno;; ++off) {
  		if (off >= len) {
  nomatch:		msgq(sp, M_BERR, "184|No match character on this line");
  			return (1);
--- 65,76 ----
  			goto nomatch;
  		return (1);
  	}
! #ifndef MULTIBYTE
! 	for (off = vp->m_start.cno;; ++off)
! #else
! 	for (off = vp->m_start.cno;; off += KEY_BLEN(sp, p[off]))
! #endif
! 	{
  		if (off >= len) {
  nomatch:		msgq(sp, M_BERR, "184|No match character on this line");
  			return (1);
***************
*** 99,104 ****
--- 114,126 ----
  		break;
  	}
  
+ #ifdef MULTIBYTE
+ 	if (gc == cs_next)
+ 		gc = cs_multi_next;
+ 	else if (gc == cs_prev)
+ 		gc = cs_multi_prev;
+ #endif /*MULTIBYTE*/
+ 
  	cs.cs_lno = vp->m_start.lno;
  	cs.cs_cno = off;
  	if (cs_init(sp, &cs))
***************
*** 162,170 ****
--- 184,205 ----
  	mp = vp->m_start.lno < vp->m_stop.lno ? &vp->m_stop : &vp->m_start;
  	if (db_get(sp, mp->lno, DBG_FATAL, &p, &len))
  		return (1);
+ #ifndef MULTIBYTE
  	for (p += mp->cno + 1, len -= mp->cno; --len; ++p)
  		if (!isblank(*p))
  			return (0);
+ #else
+     {
+ 	size_t i;
+ 	i = mp->cno + 1;
+ 	while (i < len) {
+ 		/* XXX need check for multibyte chars? */
+ 		if (!isblank(p[i]))
+ 			return (0);
+ 		i += KEY_BLEN(sp, p[i]);
+ 	}
+     }
+ #endif /*MULTIBYTE*/
  	F_SET(vp, VM_LMODE);
  	return (0);
  }
Index: vi/v_paragraph.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_paragraph.c	Sun Apr 28 00:21:26 1996
--- nvi-1.79-m17n/vi/v_paragraph.c	Tue Nov 26 00:32:37 1996
***************
*** 145,151 ****
--- 145,155 ----
  			 */
  found:			if (ISMOTION(vp)) {
  				vp->m_stop.lno = lastlno;
+ #ifndef MULTIBYTE
  				vp->m_stop.cno = lastlen ? lastlen - 1 : 0;
+ #else
+ 				vp->m_stop.cno = lastlen ? lastlen - multi_back(sp, p, &p[lastlen]) : 0;
+ #endif /*MULTIBYTE*/
  				vp->m_final = vp->m_start;
  			} else {
  				vp->m_stop.lno = lno;
***************
*** 173,179 ****
  			vp->m_start.cno = 0;
  			return (0);
  		}
! 		if (vp->m_start.cno == (len ? len - 1 : 0)) {
  			v_eof(sp, NULL);
  			return (1);
  		}
--- 177,188 ----
  			vp->m_start.cno = 0;
  			return (0);
  		}
! #ifndef MULTIBYTE
! 		if (vp->m_start.cno == (len ? len - 1 : 0))
! #else
! 		if (vp->m_start.cno == (len ? len - multi_back(sp, p, &p[len]) : 0))
! #endif
! 		{
  			v_eof(sp, NULL);
  			return (1);
  		}
***************
*** 191,197 ****
--- 200,210 ----
  		F_SET(vp, VM_RCM_SETFNB);
  	}
  	vp->m_stop.lno = lno - 1;
+ #ifndef MULTIBYTE
  	vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 	vp->m_stop.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif /*MULTIBYTE*/
  	vp->m_final = ISMOTION(vp) ? vp->m_start : vp->m_stop;
  	return (0);
  }
***************
*** 240,247 ****
  			} else
  				--vp->m_start.lno;
  			F_SET(vp, VM_LMODE);
! 		} else
  			--vp->m_start.cno;
  
  	if (vp->m_start.lno <= 1)
  		goto sof;
--- 253,270 ----
  			} else
  				--vp->m_start.lno;
  			F_SET(vp, VM_LMODE);
! 		} else {
! #ifndef MULTIBYTE
  			--vp->m_start.cno;
+ #else
+ 			CHAR_T *p;
+ 
+ 			if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL)) {
+ 				return 1;	/* is this correct? */
+ 			}
+ 			vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif /*MULTIBYTE*/
+ 		}
  
  	if (vp->m_start.lno <= 1)
  		goto sof;
Index: vi/v_replace.c
Prereq: 	10.17 
*** nvi-1.79/vi/v_replace.c	Mon Jul  1 06:50:24 1996
--- nvi-1.79-m17n/vi/v_replace.c	Wed Aug 20 15:37:29 1997
***************
*** 53,59 ****
--- 53,66 ----
  	size_t blen, len;
  	u_long cnt;
  	int quote, rval;
+ #ifndef MULTIBYTE
  	char *bp, *p;
+ #else
+ 	CHAR_T *bp, *p;
+ #endif
+ #ifdef MULTIBYTE
+ 	size_t chlen;
+ #endif
  
  	vip = VIP(sp);
  
***************
*** 87,94 ****
  	 */
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	vp->m_stop.lno = vp->m_start.lno;
  	vp->m_stop.cno = vp->m_start.cno + cnt - 1;
! 	if (vp->m_stop.cno > len - 1) {
  		v_eol(sp, &vp->m_start);
  		return (1);
  	}
--- 94,115 ----
  	 */
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	vp->m_stop.lno = vp->m_start.lno;
+ #ifndef MULTIBYTE
  	vp->m_stop.cno = vp->m_start.cno + cnt - 1;
! #else
!     {
! 	u_long i;	/* i should be u_long, since cnt is u_long*/
! 	vp->m_stop.cno = vp->m_start.cno;
! 	for (i = 0; i < cnt - 1; i++)
! 		vp->m_stop.cno += KEY_BLEN(sp, p[vp->m_stop.cno]);
!     }
! #endif /*MULTIBYTE*/
! #ifndef MULTIBYTE
! 	if (vp->m_stop.cno > len - 1)
! #else
! 	if (vp->m_stop.cno > len - multi_back(sp, p, &p[len]))
! #endif
! 	{
  		v_eol(sp, &vp->m_start);
  		return (1);
  	}
***************
*** 121,126 ****
--- 142,159 ----
  			}
  			vip->rlast = ev.e_c;
  			vip->rvalue = ev.e_value;
+ #ifdef MULTIBYTE
+ 			if (1 < (chlen = KEY_BLEN(sp, vip->rlasts[0]))) {
+ 				size_t i;
+ 				for (i = 1; i < chlen; i++) {
+ 					if (v_event_get(sp, &ev, 0, 0))
+ 						return 1;
+ 					if (ev.e_event != E_CHARACTER)
+ 						return 1;
+ 					vip->rlasts[i] = ev.e_c;
+ 				}
+ 			}
+ #endif /*MULTIBYTE*/
  			break;
  		case E_ERR:
  		case E_EOF:
***************
*** 155,160 ****
--- 188,203 ----
  	 * a single new line.  Users complained, so we match historic practice.
  	 */
  	if (!quote && vip->rvalue == K_CR || vip->rvalue == K_NL) {
+ #ifdef MULTIBYTE
+ 		/*
+ 		 * set cnt to the count by characters in buffer.
+ 		 * XXX meaning changed, assumes that cnt will not be used
+ 		 * under previous meaning in the rest of the function.
+ 		 */
+ 		cnt = vp->m_stop.cno - vp->m_start.cno;
+ 		cnt += KEY_BLEN(sp, bp[vp->m_stop.cno]);
+ #endif /*MULTIBYTE*/
+ 
  		/* Set return line. */
  		vp->m_stop.lno = vp->m_start.lno + 1;
  		vp->m_stop.cno = 0;
***************
*** 193,200 ****
--- 236,282 ----
  			rval = 0;
  		}
  	} else {
+ #ifndef MULTIBYTE
  		memset(bp + vp->m_start.cno, vip->rlast, cnt);
  		rval = db_set(sp, vp->m_start.lno, bp, len);
+ #else
+ 	    {
+ 		u_long i;	/* i must be u_long, since cnt is u_long*/
+ 		size_t nlen;
+ 		size_t orlen;
+ 		size_t nrlen;
+ 
+ 		chlen = KEY_BLEN(sp, vip->rlasts[0]);
+ 
+ 		/*
+ 		 * calculate the length.
+ 		 * orlen and nrlen denotes the region to be modified,
+ 		 * counted from vp->m_starto.cno.
+ 		 */
+ 		orlen = vp->m_stop.cno - vp->m_start.cno;
+ 		orlen += KEY_BLEN(sp, bp[vp->m_stop.cno]);
+ 		nrlen = chlen * cnt;
+ 
+ 		/* expand the region */
+ 		nlen = len - orlen + nrlen;
+ 		ADD_SPACE_RET(sp, bp, blen, nlen);
+ 
+ 		/* move trailing portion to safe place */
+ 		memmove(bp + vp->m_start.cno + nrlen,
+ 			bp + vp->m_start.cno + orlen,
+ 			len - vp->m_start.cno - orlen);
+ 
+ 		/* fill in the blank */
+ 		for (i = 0; i < cnt; i++) {
+ 			memcpy(bp + vp->m_start.cno + chlen * i,
+ 				vip->rlasts, chlen);
+ 		}
+ 
+ 		/* put it into database */
+ 		rval = db_set(sp, vp->m_start.lno, bp, nlen);
+ 		vp->m_stop.cno = vp->m_start.cno + chlen * (cnt - 1);
+ 	    }
+ #endif /*MULTIBYTE*/
  	}
  	FREE_SPACE(sp, bp, blen);
  
Index: vi/v_right.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_right.c	Sat May 18 04:11:01 1996
--- nvi-1.79-m17n/vi/v_right.c	Fri Feb 21 22:14:21 1997
***************
*** 37,44 ****
  {
  	size_t len;
  	int isempty;
! 
! 	if (db_eget(sp, vp->m_start.lno, NULL, &len, &isempty)) {
  		if (isempty)
  			goto eol;
  		return (1);
--- 37,53 ----
  {
  	size_t len;
  	int isempty;
! #ifdef MULTIBYTE
! 	CHAR_T *p;
! 	size_t lastcno;
! #endif
! 
! #ifndef MULTIBYTE
! 	if (db_eget(sp, vp->m_start.lno, NULL, &len, &isempty))
! #else
! 	if (db_eget(sp, vp->m_start.lno, &p, &len, &isempty))
! #endif /*MULTIBYTE*/
! 	{
  		if (isempty)
  			goto eol;
  		return (1);
***************
*** 50,55 ****
--- 59,69 ----
  		return (1);
  	}
  
+ #ifdef MULTIBYTE
+ 	/* how many bytes we need to subtract, to go to the last char? */
+ 	lastcno = len - multi_back(sp, p, &p[len]);
+ #endif
+ 
  	/*
  	 * Non-motion commands move to the end of the range.  Delete and
  	 * yank stay at the start.  Ignore others.  Adjust the end of the
***************
*** 59,75 ****
  	 * Historically, "[cdsy]l" worked at the end of a line.  Also,
  	 * EOL is a count sink.
  	 */
  	vp->m_stop.cno = vp->m_start.cno +
  	    (F_ISSET(vp, VC_C1SET) ? vp->count : 1);
! 	if (vp->m_start.cno == len - 1 && !ISMOTION(vp)) {
  		v_eol(sp, NULL);
  		return (1);
  	}
  	if (vp->m_stop.cno >= len) {
  		vp->m_stop.cno = len - 1;
  		vp->m_final = ISMOTION(vp) ? vp->m_start : vp->m_stop;
  	} else if (ISMOTION(vp)) {
  		--vp->m_stop.cno;
  		vp->m_final = vp->m_start;
  	} else
  		vp->m_final = vp->m_stop;
--- 73,116 ----
  	 * Historically, "[cdsy]l" worked at the end of a line.  Also,
  	 * EOL is a count sink.
  	 */
+ #ifndef MULTIBYTE
  	vp->m_stop.cno = vp->m_start.cno +
  	    (F_ISSET(vp, VC_C1SET) ? vp->count : 1);
! #else
!     {
! 	int i;
! 	if (F_ISSET(vp, VC_C1SET)) {
! 		vp->m_stop.cno = vp->m_start.cno;
! 		for (i = 0; i < vp->count; i++)
! 			vp->m_stop.cno += KEY_BLEN(sp, p[vp->m_stop.cno]);
! 	} else {
! 		vp->m_stop.cno = vp->m_start.cno
! 				+ KEY_BLEN(sp, p[vp->m_start.cno]);
! 	}
!     }
! #endif /*MULTIBYTE*/
! #ifndef MULTIBYTE
! 	if (vp->m_start.cno == len - 1 && !ISMOTION(vp))
! #else
! 	if (vp->m_start.cno == lastcno && !ISMOTION(vp))
! #endif
! 	{
  		v_eol(sp, NULL);
  		return (1);
  	}
  	if (vp->m_stop.cno >= len) {
+ #ifndef MULTIBYTE
  		vp->m_stop.cno = len - 1;
+ #else
+ 		vp->m_stop.cno = lastcno;
+ #endif
  		vp->m_final = ISMOTION(vp) ? vp->m_start : vp->m_stop;
  	} else if (ISMOTION(vp)) {
+ #ifndef MULTIBYTE
  		--vp->m_stop.cno;
+ #else
+ 		vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif
  		vp->m_final = vp->m_start;
  	} else
  		vp->m_final = vp->m_stop;
***************
*** 89,94 ****
--- 130,138 ----
  {
  	size_t len;
  	int isempty;
+ #ifdef MULTIBYTE
+ 	char *p;
+ #endif
  
  	/*
  	 * !!!
***************
*** 121,127 ****
  	 * To fix it, we let c$ go through, on the assumption that it's
  	 * not a problem for it to work.
  	 */
! 	if (db_eget(sp, vp->m_stop.lno, NULL, &len, &isempty)) {
  		if (!isempty)
  			return (1);
  		len = 0;
--- 165,176 ----
  	 * To fix it, we let c$ go through, on the assumption that it's
  	 * not a problem for it to work.
  	 */
! #ifndef MULTIBYTE
! 	if (db_eget(sp, vp->m_stop.lno, NULL, &len, &isempty))
! #else
! 	if (db_eget(sp, vp->m_stop.lno, &p, &len, &isempty))
! #endif
! 	{
  		if (!isempty)
  			return (1);
  		len = 0;
***************
*** 139,145 ****
--- 188,198 ----
  	 * Non-motion commands move to the end of the range.  Delete
  	 * and yank stay at the start.  Ignore others.
  	 */
+ #ifndef MULTIBYTE
  	vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 	vp->m_stop.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif
  	vp->m_final = ISMOTION(vp) ? vp->m_start : vp->m_stop;
  	return (0);
  }
Index: vi/v_search.c
Prereq: 	10.18 
*** nvi-1.79/vi/v_search.c	Fri Sep 20 08:42:44 1996
--- nvi-1.79-m17n/vi/v_search.c	Thu Feb 20 00:09:39 1997
***************
*** 76,82 ****
--- 76,87 ----
  	recno_t s_lno;
  	size_t len, s_cno, tlen;
  	int err, nb, type;
+ #ifndef MULTIBYTE
  	char *cmd, *t, buf[20];
+ #else
+ 	char *cmd, buf[20];
+ 	CHAR_T *t;
+ #endif
  
  	/*
  	 * !!!
***************
*** 425,430 ****
--- 430,438 ----
  	dir_t dir;
  	MARK m;
  	size_t len;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
  
  	/*
  	 * !!!
***************
*** 500,515 ****
  	 * nonblank and end at column 0 of another line.
  	 */
  	if (vp->m_start.lno < vp->m_stop.lno && vp->m_stop.cno == 0) {
  		if (db_get(sp, --vp->m_stop.lno, DBG_FATAL, NULL, &len))
  			return (1);
  		vp->m_stop.cno = len ? len - 1 : 0;
  		len = 0;
  		if (nonblank(sp, vp->m_start.lno, &len))
  			return (1);
  		if (vp->m_start.cno <= len)
  			F_SET(vp, VM_LMODE);
! 	} else
  		--vp->m_stop.cno;
  
  	return (0);
  }
--- 508,536 ----
  	 * nonblank and end at column 0 of another line.
  	 */
  	if (vp->m_start.lno < vp->m_stop.lno && vp->m_stop.cno == 0) {
+ #ifndef MULTIBYTE
  		if (db_get(sp, --vp->m_stop.lno, DBG_FATAL, NULL, &len))
  			return (1);
  		vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 		if (db_get(sp, --vp->m_stop.lno, DBG_FATAL, &p, &len))
+ 			return (1);
+ 		vp->m_stop.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif /*MULTIBYTE*/
  		len = 0;
  		if (nonblank(sp, vp->m_start.lno, &len))
  			return (1);
  		if (vp->m_start.cno <= len)
  			F_SET(vp, VM_LMODE);
! 	} else {
! #ifndef MULTIBYTE
  		--vp->m_stop.cno;
+ #else
+ 		if (db_get(sp, vp->m_stop.lno, DBG_FATAL, &p, &len))
+ 			return (1);
+ 		vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif /*MULTIBYTE*/
+ 	}
  
  	return (0);
  }
Index: vi/v_section.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_section.c	Sun Apr 28 00:21:27 1996
--- nvi-1.79-m17n/vi/v_section.c	Wed Nov 27 01:10:36 1996
***************
*** 145,154 ****
  		return (1);
  	}
  
! ret1:	if (db_get(sp, --lno, DBG_FATAL, NULL, &len))
  		return (1);
  	vp->m_stop.lno = lno;
  	vp->m_stop.cno = len ? len - 1 : 0;
  
  	/*
  	 * Non-motion commands go to the end of the range.  Delete and
--- 145,163 ----
  		return (1);
  	}
  
! ret1:
! #ifndef MULTICOLUMN
! 	if (db_get(sp, --lno, DBG_FATAL, NULL, &len))
! #else
! 	if (db_get(sp, --lno, DBG_FATAL, &p, &len))
! #endif
  		return (1);
  	vp->m_stop.lno = lno;
+ #ifndef MULTICOLUMN
  	vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 	vp->m_stop.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif
  
  	/*
  	 * Non-motion commands go to the end of the range.  Delete and
***************
*** 244,251 ****
  
  		--vp->m_start.lno;
  		F_SET(vp, VM_LMODE);
! 	} else
  		--vp->m_start.cno;
  
  	vp->m_final = vp->m_stop;
  	return (0);
--- 253,267 ----
  
  		--vp->m_start.lno;
  		F_SET(vp, VM_LMODE);
! 	} else {
! #ifndef MULTIBYTE
  		--vp->m_start.cno;
+ #else
+ 		if (db_get(sp, vp->m_start.cno, 0, &p, NULL))
+ 			return 1;
+ 		vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif
+ 	}
  
  	vp->m_final = vp->m_stop;
  	return (0);
Index: vi/v_sentence.c
Prereq: 	10.7 
*** nvi-1.79/vi/v_sentence.c	Sun Apr 28 00:21:27 1996
--- nvi-1.79-m17n/vi/v_sentence.c	Sat Nov 30 11:09:03 1996
***************
*** 51,56 ****
--- 51,62 ----
   *
   * PUBLIC: int v_sentencef __P((SCR *, VICMD *));
   */
+ #ifdef MULTIBYTE
+ /*
+  * XXX
+  * there should be a way to handle multibyte sentence termination chars.
+  */
+ #endif /*MULTIBYTE*/
  int
  v_sentencef(sp, vp)
  	SCR *sp;
***************
*** 86,98 ****
--- 92,112 ----
  	}
  
  	for (state = NONE;;) {
+ #ifndef MULTIBYTE
  		if (cs_next(sp, &cs))
+ #else
+ 		if (cs_multi_next(sp, &cs))
+ #endif
  			return (1);
  		if (cs.cs_flags == CS_EOF)
  			break;
  		if (cs.cs_flags == CS_EOL) {
  			if ((state == PERIOD || state == BLANK) && --cnt == 0) {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == 0 &&
  				    isblank(cs.cs_ch) && cs_fblank(sp, &cs))
***************
*** 192,197 ****
--- 206,217 ----
   *
   * PUBLIC: int v_sentenceb __P((SCR *, VICMD *));
   */
+ #ifdef MULTIBYTE
+ /*
+  * XXX
+  * there should be a way to handle multibyte sentence termination chars.
+  */
+ #endif /*MULTIBYTE*/
  int
  v_sentenceb(sp, vp)
  	SCR *sp;
***************
*** 232,252 ****
--- 252,284 ----
  		if (cs_bblank(sp, &cs))
  			return (1);
  		for (;;) {
+ #ifndef MULTIBYTE
  			if (cs_prev(sp, &cs))
+ #else
+ 			if (cs_multi_prev(sp, &cs))
+ #endif
  				return (1);
  			if (cs.cs_flags != CS_EOL)
  				break;
  		}
  	} else if (cs.cs_flags == 0 && !isblank(cs.cs_ch))
  		for (;;) {
+ #ifndef MULTIBYTE
  			if (cs_prev(sp, &cs))
+ #else
+ 			if (cs_multi_prev(sp, &cs))
+ #endif
  				return (1);
  			if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  				break;
  		}
  
  	for (last = 0;;) {
+ #ifndef MULTIBYTE
  		if (cs_prev(sp, &cs))
+ #else
+ 		if (cs_multi_prev(sp, &cs))
+ #endif
  			return (1);
  		if (cs.cs_flags == CS_SOF)	/* SOF is a movement sink. */
  			break;
***************
*** 279,285 ****
--- 311,321 ----
  			 * and special characters.
  			 */
  			do {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  			} while (!cs.cs_flags &&
  			    (cs.cs_ch == ')' || cs.cs_ch == ']' ||
***************
*** 303,309 ****
--- 339,349 ----
  			 * and the sentence, it could be a real sentence.
  			 */
  			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_prev(sp, &cs))
+ #else
+ 				if (cs_multi_prev(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_EOL)
  					continue;
